Configuration for top.
[profile] / setup
... / ...
CommitLineData
1#! /bin/bash
2
3set -e
4
5###--------------------------------------------------------------------------
6### Basic setup.
7
8umask 002
9
10sub=
11mkdir -p $HOME$sub
12
13: ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17###--------------------------------------------------------------------------
18### Sort out command line.
19
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
36here=$(pwd)
37
38## Suss out how to print things
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
48## Find out how to fetch things over the net
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
77###--------------------------------------------------------------------------
78### Install necessary things.
79
80echo "Installing useful scripts..."
81
82scripts="
83 lesspipe.sh start-ssh-agent svnwrap"
84for script in $scripts; do
85 $echon " $script:$echoc"
86 found=
87 for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
88 if $false [ -x $p/$script ]; then
89 found=t
90 break
91 fi
92 done
93 if [ "$found" ]; then
94 echo " already installed."
95 else
96 $echon " downloading$echoc"
97 $GETURL $HOME$sub/bin/$script $REPO/$script
98 chmod +x $HOME$sub/bin/$script
99 echo " done."
100 fi
101done
102
103echo " all done."
104
105###--------------------------------------------------------------------------
106### Install some more complicated programs.
107
108echo "Installing packages..."
109systems="
110 mlib:2.0.4:crc-mktab
111 chkpath:1.1.0:tmpdir
112"
113[ "$xstuff" ] && systems="$systems
114 xtoys:1.4.0:xatom
115"
116for system in $systems; do
117 set -- $(echo $system | tr : ' ')
118 sys=$1 ver=$2 prog=$3
119 $echon " $sys:$echoc"
120 if $false $prog >/dev/null 2>&1 --version; then
121 echo " already installed."
122 else
123 ( set -e
124 $echon " downloading$echoc"
125 cd $HOME$sub/src
126 rm -rf $sys-$ver.tar.gz $sys-$ver
127 $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
128 $echon " unpacking$echoc"
129 gzip -cd $sys-$ver.tar.gz | tar xf -
130 $echon " configuring$echoc"
131 cd $sys-$ver
132 mkdir build
133 cd build
134 ../configure --prefix=$HOME$sub >>buildlog 2>&1
135 $echon " building$echoc"
136 make >>buildlog 2>&1
137 $echon " installing$echoc"
138 make install >>buildlog 2>&1
139 echo " done."
140 )
141 fi
142done
143echo " all done."
144
145###--------------------------------------------------------------------------
146### Install global configuration.
147
148echo -n "Installing dotfile configuration:"
149if [ -f $HOME$sub/.mdw.conf ]; then
150 echo " already installed."
151else
152 cp mdw.conf $HOME$sub/.mdw.conf
153 echo " done."
154fi
155
156## Symlink the various dotfiles into place
157dotfiles="
158 bash_profile bash_logout bashrc inputrc bash_completion
159 emacs emacs-calc vm
160 vimrc mg
161 mailrc signature
162 cgrc tigrc
163 gdbinit
164 guile
165 toprc
166 aspell.conf
167 lisp-init.lisp:.cmucl-init.lisp
168 lisp-init.lisp:.sbclrc
169 lisp-init.lisp:.clisprc.lisp
170 lisp-init.lisp:.eclrc
171 dircolors colordiffrc screenrc cvsrc indent.pro"
172[ "$xstuff" ] && dotfiles="$dotfiles
173 xinitrc xsession Xdefaults vncrc vncsession
174 putty-defaults:.putty/sessions/Default%20Settings
175 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
176 e-keybindings.cfg:.enlightenment/keybindings.cfg
177 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
178 e16-bindings:.e16/bindings.cfg
179 e16-config:.e16/e_config--1.0.cfg
180 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg
181 jue-peek.jpg:.e16/backgrounds/jue-peek.jpg"
182echo "Installing dotfiles..."
183for d in $dotfiles; do
184 target=.$d
185 case $d in
186 *:*) target=${d#*:} d=${d%%:*};;
187 esac
188 ft=$HOME$sub/$target
189 dir=${ft%/*}
190 mkdir -p $dir
191 ln -s $here/$d $ft.new
192 mv $ft.new $ft
193 echo " $target"
194done
195echo " all done."
196
197###--------------------------------------------------------------------------
198### Process the Git configuration.
199
200echo -n "Installing Git configuration:"
201sed "
2021i\
203### generated by $here/setup; do not edit!\
204
205/@releasekey@/ s::$(./mdw-conf release-key 481334C2):g
206/@gitignore@/ s::$(./mdw-conf gitignore $here/gitignore):g
207" gitconfig >$HOME/.gitconfig.new
208mv $HOME/.gitconfig.new $HOME/.gitconfig
209echo " done."
210
211###--------------------------------------------------------------------------
212### Install useful scripts included in this package.
213
214scripts="
215 mdw-editor
216 mdw-conf
217 movemail-hack
218 emerge-hack"
219[ "$xstuff" ] && scripts="$scripts
220 xrun
221 xshutdown"
222echo "Installing scripts..."
223mkdir -p $HOME$sub/bin
224for s in $scripts; do
225 ft=$HOME$sub/bin/$s
226 ln -s $here/$s $ft.new
227 mv $ft.new $ft
228 echo " $s"
229done
230echo " all done."
231
232###--------------------------------------------------------------------------
233### Set up the Emacs config.
234
235$echon "Finding a suitable emacs:$echoc"
236emacs=no
237for i in emacs22 emacs21 emacs; do
238 if type -p >/dev/null $i; then
239 emacs=$i
240 break
241 fi
242done
243if [ $emacs = no ]; then
244 echo " failed."
245 emacs=:
246else
247 echo " $emacs."
248fi
249
250echo "Installing Emacs packages..."
251emacspkg="
252 make-regexp
253 git git-blame vc-git stgit
254 quilt"
255for elib in $emacspkg; do
256 $echon " $elib:$echoc"
257 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
258 (progn
259 (setq load-path (nconc load-path (list "~/lib/emacs")))
260 (kill-emacs (condition-case nil
261 (progn (load-library "'"$elib"'") 0)
262 (error 1))))'; then
263 echo " already installed."
264 else
265 $echon " downloading$echoc"
266 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
267 $echon " compiling$echoc"
268 (cd $HOME$sub/lib/emacs;
269 $emacs >/dev/null 2>&1 --no-site-file --batch \
270 --eval '(byte-compile-file "'"$elib.el"'")')
271 echo " done."
272 fi
273done
274echo " all done."
275
276$echon "Setting up Emacs configuration:$echoc"
277$echon " linking$echoc"
278for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
279 set -- $(echo $link | tr : ' ')
280 from=$1 to=$2
281 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
282 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
283done
284$echon " compiling$echoc"
285make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
286echo " done."
287
288###----- That's all, folks --------------------------------------------------